//
// Created by E201948J on 07/01/2022.
//
#include <fcntl.h>
#include <sys/mman.h>
#include <sys/stat.h>
#include <sys/types.h>

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <unistd.h>

/**
 * copy the file using systems io
 */
void copy_with_read()
{
    int src = open("in.bin", O_RDONLY, S_IRUSR|S_IWUSR);
    int dst = open("out.bin", O_WRONLY|O_TRUNC|O_CREAT, S_IRUSR|S_IWUSR);

    char buff[4096];
    ssize_t nread;

    while((nread = read(src, buff, 4096)) > 0)
    {
        write(dst, buff, nread);
    }

    close(src);
    close(dst);
}

/**
 * copy the file without transfer to user space
 */
void copy_with_mmap(){
    int fd = open("in.bin", O_RDONLY, S_IRUSR | S_IWUSR);

    struct stat fileStat;
    fstat(fd, &fileStat);

    char *src = mmap(NULL, fileStat.st_size, PROT_READ, MAP_PRIVATE, fd, 0);
    int dfd = open("out.bin", O_RDWR | O_CREAT, 0666);
    ftruncate(dfd, fileStat.st_size);
    char *dest = mmap(NULL, fileStat.st_size, PROT_READ | PROT_WRITE, MAP_SHARED, dfd, 0);

    memcpy(dest, src, fileStat.st_size);

    munmap(src, fileStat.st_size);
    munmap(dest, fileStat.st_size);

    close(fd);
    close(dfd);

    return;
}

int main(void)
{
    clock_t begin, end;
    const int LOOPS = 500;

    begin = clock();
    for(int i=0; i<LOOPS; i++)
    {
        copy_with_read();
    }
    end = clock();
    fprintf(stdout, "with std io: %e\n", (double)(end-begin) / CLOCKS_PER_SEC);

    begin = clock();
    for(int i=0; i<LOOPS; i++)
    {
        copy_with_mmap();
    }
    end = clock();
    fprintf(stdout, "with mapped io: %e\n", (double)(end-begin) / CLOCKS_PER_SEC);

    fprintf(stdout, "done.\n");
    exit(0);
}

